=== debian/changelog ===
sphinxsearch (2.2.11-8) unstable; urgency=medium

  * Fix FTBFS on Hurd: don’t call pthread_attr_setstacksize if
    PTHREAD_STACK_MIN is not defined.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 03 Dec 2021 20:32:53 +0100

sphinxsearch (2.2.11-7) unstable; urgency=medium

  * Build-Depend on pkgconf.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 03 Dec 2021 15:26:40 +0100

sphinxsearch (2.2.11-6) unstable; urgency=medium

  [ Helmut Grohne ]
  * Use pkg-config instead of mysql_config (Closes: #917137).

  [ Andrej Shadura ]
  * Build-Depend on unixodbc-dev.
  * Use pkg-config to detect libre2 (fixes FTBFS on non-x86).

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 03 Dec 2021 14:21:45 +0100

sphinxsearch (2.2.11-5) unstable; urgency=medium

  * New maintainer (Closes: #939763).
  * Add gbp.conf.
  * Convert copyright file to machine-readable format.
  * Add exclusions for current and future releases.
  * Simplify the init script (Closes: #861262, #772370, #656326).
  * Fix the crontab user (Closes: #656326).
  * Update the sample/minimal conf files to match installation paths.
  * Don't install an extra copy of the configuration sample.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set Standards-Version: 4.6.0.
  * Drop B-D on dh-autoreconf, autotools-dev and adduser.
  * Enable re2 support.
  * Move the example.sql to /usr/share/doc (Closes: #871944).

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 03 Dec 2021 10:41:03 +0100

sphinxsearch (2.2.11-4) unstable; urgency=medium

  * Trim trailing whitespace.
  * Drop use of autotools-dev debhelper.
  * Remove uploaders from orphaned package.
  * Wrap and sort.
  * Use debian-compat 13.
  * Simplify autoconf handing in debian/rules.
  * Fix the default address in the sample config
    (Closes: #939762, CVE-2019-14511)

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 02 Dec 2021 20:31:20 +0100

sphinxsearch (2.2.11-3) unstable; urgency=medium

  [ Vasyl Gello ]
  * Fix arbitrary file reads by scattered file snippets
    (CVE-2020-29050)

  [ Lucas Kanashiro ]
  * Fix handshake implementation of MySQL protocol to support MySQL 8
    clients (LP: #1855468)

  [ Andrej Shadura ]
  * Update Maintainer/Uploaders (Closes: #858689)

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 02 Dec 2021 20:13:11 +0100

sphinxsearch (2.2.11-2) unstable; urgency=medium

  * Fix upstream bug 2540: daemon crash on snippet generation
    for empty documents with html_strip enabled. (Closes: #869097)

 -- YunQiang Su <syq@debian.org>  Sun, 20 Aug 2017 11:08:24 +0800

sphinxsearch (2.2.11-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch Build-Depends to default-libmysqlclient-dev.
    (Closes: #845911)

 -- Christian Hofstaedtler <zeha@debian.org>  Mon, 19 Dec 2016 01:53:57 +0000

sphinxsearch (2.2.11-1) unstable; urgency=medium

  * New upstream release.
  * Bump standard version to 3.9.8.

 -- YunQiang Su <syq@debian.org>  Wed, 26 Oct 2016 13:49:22 +0800
