=== debian/control ===
Source: sphinxsearch
Section: misc
Priority: optional
Maintainer: Andrej Shadura <andrewsh@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 default-libmysqlclient-dev,
 docbook-to-man,
 gawk,
 libexpat-dev,
 libre2-dev,
 libpq-dev,
 libstemmer-dev,
 pkgconf,
 unixodbc-dev
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/debian/sphinxsearch.git
Vcs-Browser: https://salsa.debian.org/debian/sphinxsearch

Package: sphinxsearch
Architecture: any
Depends:
 adduser,
 sysvinit-utils,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fast standalone full-text SQL search engine
 Sphinx is a standalone full text search engine, meant to provide fast,
 size-efficient and relevant fulltext search functions to other applications.
 Sphinx was specially designed to integrate well with SQL databases and
 scripting languages. Currently built-in data sources support fetching data
 either via direct connection to MySQL or PostgreSQL, or using XML pipe
 mechanism (a pipe to indexer in special XML-based format which Sphinx
 recognizes).
 .
 Sphinx is an acronym which is officially decoded as SQL Phrase Index.
