=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
            --localstatedir=/var/lib/sphinxsearch --sysconfdir=/etc/sphinxsearch --with-libstemmer --with-pgsql --with-re2

execute_after_dh_auto_install:
	# Move the examples
	mkdir -p debian/sphinxsearch/usr/share/doc/sphinxsearch
	mv debian/sphinxsearch/etc/sphinxsearch/sphinx.conf.dist debian/sphinxsearch/usr/share/doc/sphinxsearch/sphinx.conf.sample
	mv debian/sphinxsearch/etc/sphinxsearch/example.sql debian/sphinxsearch/usr/share/doc/sphinxsearch/

override_dh_auto_test:
